
#ifndef __ARCHIO_H
#define __ARCHIO_H

#ifndef __DEFCONF_H
#include "defconf.h"
#endif

typedef struct ARCH_FILE_
{
	int fd;
	int writing;
	int appending;
	int level;
	int method;
}ARCH_FILE;

extern int Nblocks;
extern char *Current_file_name;	/* Name of current file */;
extern long Current_file_size;	/* Size of current file */;
extern int Current_file_mode;	/* Size of current file */;
extern time_t Current_file_mtime; /* Modified time of current file */;
extern long Current_file_left;	/* Left bytes in current file */;
extern void check_vol(char *name, struct stat *p);
extern int fill_buff(ARCH_FILE *arch_fp);
extern int read_arch(ARCH_FILE *arch_fp, long n, char **ptr);
extern int start_write_arch(int n);
extern int buff_arch(ARCH_FILE *arch_fp, int n, char **ptr);
extern int write_arch(int n);
extern /*int*/ ARCH_FILE * open_arch(char *fname, char *mode);
extern int close_arch(ARCH_FILE *arch_fp/*char command*/);
extern int open_dev(char *file, char mode);

extern int read_zZ(ARCH_FILE *arch_fp/*int Afd*/,char *Buff,int Buffsize);
extern int write_z(ARCH_FILE *arch_fp/*int fh*/,char *buf,int bufsize);

#if P_up_V>=4
extern void gzip_file(char *pack,char *unpack);
extern int get_gunzip_fname(char *unpackfn,char *packfn);
extern void gunzip_file(char *pack,char *unpack);
#endif
#ifdef DLL
void arch_SetAfd(int fh);
int arch_GetAfd(void);
extern void arch_static_init(void);
extern int get_access_method(void);
#endif

#endif /* __ARCHIO_H */
